-- _|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|
-- Title   : AndorShot
-- Version : Ver0.1.13.0508EN
-- Notes   : アンデラ射撃場支援アドオン アンデラショット
-- Author  : 胡喜媚
-- _|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|_|

-- ========================================================================
-- <summary>[NAMESPACE]アドオン定義</summary>
-- ========================================================================
local conAddonName = "AndorShot"        -- アドオン名
local conAddonVer  = "Ver0.1.13.0508EN" -- バージョン
local AndorShot    = {}                 -- ネームスペース
_G.AndorShot       = AndorShot          -- グローバルスコープ登録

-- ========================================================================
-- <summary>[CONSTANT]定数</summary>
-- ========================================================================

-- ========================================================================
-- <summary>[MEMBER]メンバ変数</summary>
-- ========================================================================

-- ========================================================================
-- <summary>[SLASH]スラッシュコマンド定義</summary>
-- ========================================================================

-- ========================================================================
-- <summary>[SLASH]スラッシュコマンド実体</summary>
-- ========================================================================

---------------------------------------------------------------------------

-- ========================================================================
-- <summary>[EVENT]イベント定義</summary>
-- ========================================================================
---------------------------------------------------------------------------
--- 【EVENT】AndorShotのロード時に起動します。
---  @param  this 呼出元オブジェクト
---  @return 無し
---  @usage  AndorShot.OnLoad(this)
---------------------------------------------------------------------------
function AndorShot.OnLoad(this)
    -- イベントハンドラ登録
    this:RegisterEvent("UPDATE_MOUSEOVER_UNIT")   -- マウスカーソルがユニット上を移動したイベント
    
    -- 起動完了メッセージ
    DEFAULT_CHAT_FRAME:AddMessage("|H|h|cffeeeeee" .. conAddonName .. " " .. conAddonVer .. "|h|r |H|h|cffff88ff起動しました。|h|r")
end
---------------------------------------------------------------------------

---------------------------------------------------------------------------
--- 【EVENT】AndorShotで発生したイベントを捕捉します。
---  @param  this  呼出元オブジェクト
---  @param  event イベント種別
---  @param  arg1  パラメータ1
---  @param  arg2  パラメータ2
---  @param  arg3  パラメータ3
---  @param  arg4  パラメータ4
---  @return 無し
---  @usage  AndorShot.OnEvent(this, event, arg1, arg2, arg2, arg4)
---------------------------------------------------------------------------
function AndorShot.OnEvent(this, event, arg1, arg2, arg3, arg4)
    -- 発生したイベントの種類を判定します。
    if (event == "UPDATE_MOUSEOVER_UNIT") then
        ---------------------------------------------------------------------------
        -- マウスカーソルがユニット上を移動したイベント
        ---------------------------------------------------------------------------
        -- マウスポインタがユニットを外れた時は、arg2(ID)が0のイベントが発生
        if (arg2 ~= 0) then
            -- arg2(ID)が0以外の場合のみイベントを処理します。
            AndorShot.UnitOnMouseOver(event, arg1, arg2)
        end
    end
end
---------------------------------------------------------------------------

---------------------------------------------------------------------------
--- 【EVENT】マウスポインタがユニット上を移動したイベント
---  @param  this  呼出元オブジェクト
---  @param  event イベント種別
---  @param  arg1  パラメータ1
---  @param  arg2  パラメータ2
---  @param  arg3  パラメータ3
---  @param  arg4  パラメータ4
---  @return 無し
---  @usage  AndorShot.UnitOnMouseOver(this, event, arg1, arg2, arg2, arg4)
---------------------------------------------------------------------------
function AndorShot.UnitOnMouseOver(event, sUnitName, ID)
    if (sUnitName == "Tortoise") then
        -- Shiftを押している場合は攻撃しない
        if (IsShiftKeyDown() == false) then
            UseExtraAction(1)
            SpellTargetUnit("mouseover")
        end
    elseif (sUnitName == "Fiery Newt") then
        -- Ctrlを押している場合は攻撃しない
        if (IsCtrlKeyDown() == false) then
            UseExtraAction(1)
            SpellTargetUnit("mouseover")
        end
    elseif (sUnitName == "Running Rabbit") then
        -- Altを押している場合は攻撃しない
        if (IsAltKeyDown() == false) then
            UseExtraAction(1)
            SpellTargetUnit("mouseover")
        end
    elseif (sUnitName == "Armored Bug") then
        -- Altを押している場合は攻撃しない
        if (IsAltKeyDown() == false) then
            UseExtraAction(1)
            SpellTargetUnit("mouseover")
        end
    elseif (sUnitName == "Ammunition Turtle") then
        UseExtraAction(1)
        SpellTargetUnit("mouseover")
    end
end
---------------------------------------------------------------------------

-- ========================================================================
-- <summary>[EVENT]メソッド定義</summary>
-- ========================================================================

-- ========================================================================
-- End of File
-- ========================================================================

